#!/usr/bin/env python
# -*- coding: utf-8 -*-
## Copyright (C) 2010 Bamacharan Kundu <bamachrn@gmail.com>

## This program is free software; you can redistribute it and/or modify
## it under the terms of the GNU General Public License as published by
## the Free Software Foundation; either version 2 of the License, or
## (at your option) any later version.

## This program is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
## GNU General Public License for more details.

## You should have received a copy of the GNU General Public License
## along with this program; if not, write to the Free Software
## Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

import gtk,gobject
import pygtk
import openzilla_db 
import time
import thread
import threading
import string
import re
gtk.gdk.threads_init()


class openzillaGUI :

    #openzilla_db.openzillaSql()

    def __init__(self):
        self.builder=gtk.Builder()
        self.builder.add_from_file("openzilla.glade")
        self.builder.connect_signals(self)
        self.window0 = self.builder.get_object("window1")
        self.window0.set_icon_from_file("/usr/share/pixmaps/openzilla.png")
        self.window = self.builder.get_object("window")
        self.window.set_icon_from_file("/usr/share/pixmaps/openzilla.png")
        self.dialog = self.builder.get_object("messagedialog")
        self.filldialog = self.builder.get_object("filldialog")
        self.vbox8 = self.builder.get_object("vbox8")
        list_url = ["http://bugs.dwscoalition.org/","http://bugs.eclipse.org/bugs","https://bugs.eclipse.org/bugs","https://bugs.freedesktop.org/","https://bugs.gentoo.org/","http://bugs.gentoo.org/","https://bugs.kde.org/","http://bugs.kde.org/","http://bugs.linuxbase.org/","http://bugs.winehq.org/","http://bugs.xaraya.com/","http://bugs.xfree86.org/","http://bugzilla.abisource.com/","http://bugzilla.achievo.org/","http://bugzilla.almworks.com/","https://bugzilla.gnome.org/","http://bugzilla.gnome.org/","http://bugzilla.icculus.org/","http://bugzilla.kernel.org/","https://bugzilla.mozilla-russia.org/","http://bugzilla.mozilla.org/","https://bugzilla.mozilla.org/","http://bugzilla.mplayerhq.hu/","https://bugzilla.osafoundation.org/","http://bugzilla.qooxdoo.org/","https://bugzilla.redhat.com/","https://bugzilla.redhat.com/bugzilla","http://bugzilla.robotyka.ia.pw.edu.pl/","https://bugzilla.samba.org/","http://bugzilla.songbirdnest.com/","http://bugzilla.wikimedia.org/","http://bugzilla.zimbra.com/","http://cool.ars-grin.gov/bugz","http://d.puremagic.com/issues","http://defect.opensolaris.org/bz","http://gcc.gnu.org/bugzilla","http://issues.apache.org/bugzilla","http://issues.apache.org/SpamAssassin","https://landfill.bugzilla.org/bugzilla-3.2-branch","https://landfill.bugzilla.org/bugzilla-3.4-branch","http://locke.dcnicn.com/bugzilla/iso10303","http://oss.sgi.com/bugzilla","https://www.mozdev.org/bugs","http://www.reactos.org/bugzilla","http://www.w3.org/bugs/public"]
        self.base_url = gtk.combo_box_entry_new_text()

        self.base_url.set_tooltip_text("Enter the base URL")
        for x in list_url:
          self.base_url.append_text(x)
        self.base_url.set_active(25)
        self.base_url.show()
        self.vbox8.pack_start(self.base_url)

        open_db = openzilla_db.openzillaSql()
        self.uname = self.builder.get_object("uname")
        self.uname.set_tooltip_text("Enter the User name or Email ID")
        self.password = self.builder.get_object("password")
        self.password.set_tooltip_text("Enter the Password for the user")
        self.login = self.builder.get_object("login_btn")
        self.login.set_tooltip_text("Click to login")
        self.login.connect("clicked",self.login_clicked)
        self.ccview = self.builder.get_object("textview1")
        self.adduser = self.builder.get_object("adduser")
        self.addcc = self.builder.get_object("addcc")
        self.removecc = self.builder.get_object("removecc")

        """self.search_menu = self.builder.get_object("menuitem3")
        self.searchmenu = gtk.SubMenu("Search")
        self.search_menu.set_submenu(self.searchmenu)
        """


        #///////////////////////New bug Window///////////
        self.product_window = self.builder.get_object("window3")
        self.product_window.set_icon_from_file("/usr/share/pixmaps/openzilla.png")
        #///////////////////////////New bug Window
        self.newtab = self.builder.get_object("label1")
        self.list_pan = self.builder.get_object("vpaned1")
        self.detail_pan = self.builder.get_object("vbox1")
        self.bug_id_disp = self.builder.get_object("select_bug_id")
        self.bug_description_disp = self.builder.get_object("select_bug_description")
        self.treestore = gtk.TreeStore(str)
        list_entry = ['bugzilla.redhat.com']
        for parent in list_entry:
            piter = self.treestore.append(None, [parent])
            sub_parent = ["User Queries","Sample Queries","Temporary Queries","Remote Queries","Outbox"] 
            for query in sub_parent :
                sq = self.treestore.append(piter, [query])
                if query == "Sample Queries":
                    if open_db.account_check() != None :
                        me = open_db.account_check()[0]
                    else:
                        me = 'Me'
                    s1 = "Assigned to "+me
                    s2 = "Reported by "+me
                    sample_quer = ["All Bugs",s1,s2,"Requests"]
                    for s_query in sample_quer:
                        prio = self.treestore.append(sq, [s_query])
                        if s_query == s1:
                            value = "Priority"
                            priority = self.treestore.append(prio,[value])
                            values = ["Urgent","High","Medium","Low"]
                            for value in values:
                                self.treestore.append(priority,[value])

                        if s_query == s2:
                            value = "Status"
                            priority = self.treestore.append(prio,[value])
                            values = ["NEW","ASSIGNED","MODIFIED","ON_DEV","ON_QA","VERIFIED","RELEASE_PENDING","POST","CLOSED"]
                            for value in values:
                                self.treestore.append(priority,[value])

                        if s_query == "Requests":
                            values = [me+" Requested",me+" was Requested"]
                            for value in values:
                                self.treestore.append(prio,[value])

                if query == "Remote Queries":
                    r_query = me+"'s Bugs"
                    self.treestore.append(sq,[r_query])   

        self.treeview = gtk.TreeView(self.treestore)
        self.tvcolumn = gtk.TreeViewColumn('Queries')
        self.treeview.append_column(self.tvcolumn)
        self.cell = gtk.CellRendererText()
        self.tvcolumn.pack_start(self.cell, True)
        self.tvcolumn.add_attribute(self.cell, 'text', 0)
        self.treeview.set_search_column(0)
#        self.tvcolumn.set_sort_column_id(0)
        self.treeview.set_reorderable(True)
        self.treeview.columns_autosize()
        self.treeview.expand_all()
        self.selection = self.treeview.get_selection()
        self.selection.connect('changed', self.tree_select_changed)
        self.scrolledwindow2 = self.builder.get_object("scrolledwindow2")
        self.scrolledwindow2.add_with_viewport(self.treeview)
        self.hpan = self.builder.get_object("hpaned1")
        self.hpan.set_position(250)
        self.about_button = self.builder.get_object("about_button")
        self.about_button.connect('clicked',self.on_about_clicked)
        self.comments = self.builder.get_object("comments") 
        self.attachment = self.builder.get_object("attachment") 
        self.description = self.builder.get_object("description") 
        self.assigned_to = self.builder.get_object("assigned_to") 
        self.creation_ts = self.builder.get_object("creation_ts") 
        self.delta_ts = self.builder.get_object("delta_ts") 
        self.bug_status = self.builder.get_object("bug_status") 
        self.resolution = self.builder.get_object("resolution") 
        self.bug_file_loc = self.builder.get_object("bug_file_loc") 
        self.bug_severity = self.builder.get_object("bug_severity") 
        self.priority = self.builder.get_object("priority") 
        self.target_milestone = self.builder.get_object("target_milestone") 
        self.reporter = self.builder.get_object("reporter") 
        self.rep_platform = self.builder.get_object("rep_platform") 
        self.op_sys = self.builder.get_object("op_sys") 
        self.product =self.builder.get_object("product") 
        self.component = self.builder.get_object("component")
        self.status_whiteboard = self.builder.get_object("status_whiteboard") 
        self.keywords = self.builder.get_object("keywords") 
        self.search = self.builder.get_object("search")
        word = self.search.get_text()
        self.search.connect('changed',self.search_changed)

        #//////////////////select product
        self.sel_list = []
        self.product_tree = ['Enable','Product']
        self.product_store = gtk.TreeStore(gobject.TYPE_BOOLEAN,gobject.TYPE_STRING)
        #self.liststore = gtk.list_store_new(5,int,str,str,str,str)

        self.product_entry = ["389","Auditor","Beaker","Bugtool","Bugzilla","Dogtag Certificate System","eCos","eGroupware","Fedora","Fedora Documentation","Fedora EPEL","Fedora Hosted Projects","Fedora Infrastructure","Fedora Legacy","Fedora Localization","Fedora Management Console","Fedora OLPC","freeIPA","JBoss Enterprise Application Platform","JBoss Enterprise BRMS Platform","JBoss Enterprise Portal Platform","JBoss Enterprise SOA Platform","JBoss Enterprise Web Server for Red Hat Enterprise Linux 4","JBoss Enterprise Web Server for Red Hat Enterprise Linux 5","Knowledgebase","penrose","Pulp","Red Hat Academy","Red Hat Advanced Server Developer Edition","Red Hat Application Server","Red Hat Application Server Public Beta","Red Hat Cluster Suite","Red Hat Contrib|Net","Red Hat Database","Red Hat Developer Program","Red Hat Developer Suite","Red Hat Enterprise CMS","Red Hat Enterprise Linux 2.1","Red Hat Enterprise Linux 3","Red Hat Enterprise Linux 4","Red Hat Enterprise Linux 5","Red Hat Enterprise Linux 6","Red Hat Enterprise MRG","Red Hat Enterprise Portal Server","Red Hat Hardware Certification Program","Red Hat High Availability Server","Red Hat HPC Solution","Red Hat Linux","Red Hat Linux Beta","Red Hat Network","Red Hat Network","Proxy","Red Hat Network Satellite","Red Hat Powertools","Red Hat Powertools Public Beta","Red Hat Public Beta","Red Hat Raw Hide","Red Hat Ready Certification Tests","Red Hat Secure Web Server","Red Hat Update Infrastructure for Cloud Providers","Red Hat Web Application Framework","Red Hat Web Site","RHQ Project","Security Response","Source-Navigator","Spacewalk","Stronghold 4.0 for Red Hat Advanced Server","Stronghold Cross Platform","Stronghold for Red Hat Linux","TZOL Calendaring System","Vault","velo","Virtualization Tools"]
        self.topic =[]
        for row in self.product_entry :
            self.product_store.append(None,(None,row))
        self.product_list_tree = gtk.TreeView(self.product_store)
        self.cell_toggled = gtk.CellRendererToggle()
        self.cell_toggled.set_property('activatable',True)
        self.cell_toggled.connect('toggled',self.product_toggled,self.product_store)
        self.cell_data1 = gtk.CellRendererText()
        self.column = gtk.TreeViewColumn("Selected",self.cell_toggled)
        self.column.add_attribute(self.cell_toggled,'active',0)
        self.column1 = gtk.TreeViewColumn("Name",self.cell_data1,text = 1)
        self.product_list_tree.append_column(self.column)
        self.product_list_tree.append_column(self.column1)
        self.product_list_tree.set_headers_visible(True)
        self.product_list_tree.columns_autosize()
        self.scrolledwindow5 = self.builder.get_object("scrolledwindow5")
        self.scrolledwindow5.add_with_viewport(self.product_list_tree)
        self.viewport = self.builder.get_object("viewport3")
        self.viewport1 = self.builder.get_object("viewport4")

        radio_select = gtk.RadioButton(None,"Select one or more product(s) from the list below")
        radio_select.connect("toggled",self.select_radio,"custom select")
        self.viewport.add(radio_select)
        radio_select.set_active(True)

        radio_select = gtk.RadioButton(radio_select,"Select all the products")
        radio_select.connect("toggled",self.select_radio,"all select")
        self.viewport1.add(radio_select)

        """self.selection_product = self.product_list_tree.get_selection()
        #self.tvcolumn_list.add_attribute(self.cell_data,'active', 0)
        self.selection_product.connect('changed', self.product_select_changed)"""


        #///////////////////bug list view//////////////////


        #open_db = openzillaSql()
        #self.list_treestore = gtk.TreeStore(str)
        self.list_tree = ['Bug ID', 'Status', 'Priority', 'Assignee',  'Description']
        self.list_store = gtk.ListStore(str,str,str,str,str)
        #self.liststore = gtk.list_store_new(5,int,str,str,str,str)

        list_entry = open_db.get_list('satast')
        #print list_entry

        for row in list_entry :
            self.list_store.append(row)
        self.bug_list_tree = gtk.TreeView(self.list_store)
        self.cell_data = gtk.CellRendererText()
        i=0
        for title in self.list_tree :
            self.tvcolumn_list = gtk.TreeViewColumn(title)
            self.tvcolumn_list.pack_start(self.cell_data, True)
            self.tvcolumn_list.add_attribute(self.cell_data, 'text',i)
            self.bug_list_tree.append_column(self.tvcolumn_list)
            i=i+1
        self.bug_list_tree.set_search_column(0)
        self.bug_list_tree.set_reorderable(True)
        self.bug_list_tree.set_headers_visible(True)
        self.bug_list_tree.columns_autosize()
        self.scrolledwindow1 = self.builder.get_object("scrolledwindow1")
        self.scrolledwindow1.add_with_viewport(self.bug_list_tree)
        self.selection_bug = self.bug_list_tree.get_selection()
        self.selection_bug.connect('changed', self.list_select_changed)
        #print self.selection_bug
        #///////////////bug_list_view

    def product_toggled(self,cell,path,model):
        model[path][0] = not model[path][0]
        if model[path][0]:
            self.sel_list.append(model[path][1])
        else :
            self.sel_list.remove(model[path][1])
        self.topic = ''    
        for i in self.sel_list:
            self.topic = self.topic+'_'+i 
        #print self.topic

    def select_radio(self,widget,data = None):
        if data == "all select" and widget.get_active():
            self.cell_toggled.set_property('activatable',False)
            self.topic = ''
            for i in self.product_entry:
                self.topic = self.topic+'_'+i 

        else :
            self.cell_toggled.set_property('activatable',True)

    def new_bug_detail(self):
        self.new_bug = self.builder.get_object("newbug")
        self.new_bug.set_title("openZilla New bug")
        self.new_bug.set_icon_from_file("/usr/share/pixmaps/openzilla.png")
        self.new_bug_btn = self.builder.get_object("new_bug_btn")
        self.upload_btn = self.builder.get_object("upload")
        self.upload_btn.connect('clicked',self.on_upload_clicked)

        self.acc_holder = self.builder.get_object("account_holder")
        self.acc_holder.set_text(open_db.me)
        self.save_draft_btn = self.builder.get_object("save_draft")
        #self.save_draft_btn.connect('clicked',self.on_save_draft_clicked)

        self.cancel_btn = self.builder.get_object("cancel")
        #self.cancel_btn.connect('clicked',self.on_cancel_clicked)

        self.attach_btn = self.builder.get_object("attach_file")
        self.attach_btn.connect('clicked',self.on_attach_clicked)
        self.attach_btn.set_tooltip_text("Click the button to attach files for bug")

        self.screen_btn = self.builder.get_object("attach_screen")
        self.screen_btn.connect('clicked',self.on_attach_clicked)
        self.screen_btn.set_tooltip_text("Click the button to attach screen shots for bug")
        
        self.summary = self.builder.get_object("summary")
        self.summary_txt = self.summary.get_text()
        self.summary.set_tooltip_text("Enter the summary for bug")
        
        self.depend = self.builder.get_object("depend")
        self.depends_txt = self.depend.get_text()
        self.depend.set_tooltip_text("Enter the dependent bug id for bug")
        
        self.keyword = self.builder.get_object("keyword")
        self.keyword_txt = self.keyword.get_text()
        self.keyword.set_tooltip_text("Enter the keywords for bug")
        
        self.blocks = self.builder.get_object("blocks")
        self.blocks_txt = self.blocks.get_text()
        self.blocks.set_tooltip_text("Enter the blocks for bug")
        
        self.flags = self.builder.get_object("flags")
        self.flags_txt = self.flags.get_text()
        self.flags.set_tooltip_text("Enter the flags for bug")
        
        self.clone_of = self.builder.get_object("clone_of")
        self.clone_of_txt = self.clone_of.get_text()
        self.clone_of.set_tooltip_text("Enter the bug id which is clone of it")
        self.table4 = self.builder.get_object("table4")
    
        list_status = ["NEW","ASSIGNED","MODIFIED","ON_DEV","ON_QA","VERIFIED","RELEASE_PENDING","POST","CLOSED"]
        self.status = gtk.combo_box_entry_new_text()
        self.status.set_tooltip_text("Enter current status of bug")
        for x in list_status:
          self.status.append_text(x)
        self.status.show()
        self.table4.attach(self.status,1,2,1,2)
        
        list_version = open_db.get_version()
        self.version = gtk.combo_box_entry_new_text()
        self.version.set_tooltip_text("Enter the version of application")
        for x in list_version:
            self.version.append_text(x)
        self.version.show()
        self.table4.attach(self.version,1,2,2,3)
    
        list_hardware = open_db.get_hardware()
        self.hardware = gtk.combo_box_entry_new_text()
        self.hardware.set_tooltip_text("Enter the architechture on which application is running")
        for x in list_hardware:
            self.hardware.append_text(x)
        self.hardware.show()
        self.table4.attach(self.hardware,1,2,3,4)
    
        list_priority = ["Urgent","High","Medium","Low"]
        self.priority_com = gtk.combo_box_entry_new_text()
        self.priority_com.set_tooltip_text("Enter the priority of the bug")
        for x in list_priority:
            self.priority_com.append_text(x)
        self.priority_com.show()
        self.table4.attach(self.priority_com,1,2,4,5)
    
        list_assignee = open_db.get_assigned_to()
        self.assignee = gtk.combo_box_entry_new_text()
        self.assignee.set_tooltip_text("Enter the email id to whom the bug is assigned")
        for x in list_assignee:
            self.assignee.append_text(x)
        self.assignee.show()
        self.table4.attach(self.assignee,1,2,5,6)
    
        list_severity = open_db.get_severity()
        self.severity = gtk.combo_box_entry_new_text()
        self.severity.set_tooltip_text("Enter the email id to whom the bug is assigned")
        for x in list_severity:
            self.severity.append_text(x)
        self.severity.show()
        self.table4.attach(self.severity,3,4,4,5)
    
        list_op_sys = open_db.get_op_sys()
        self.op_sys = gtk.combo_box_entry_new_text()
        self.op_sys.set_tooltip_text("Enter the email id to whom the bug is assigned")
        for x in list_op_sys:
          self.op_sys.append_text(x)
        self.op_sys.show()
        self.table4.attach(self.op_sys,3,4,3,4)
    
        list_component = open_db.get_component()
        self.component = gtk.combo_box_entry_new_text()
        self.component.set_tooltip_text("Enter the email id to whom the bug is assigned")
        for x in list_component:
          self.component.append_text(x)
        self.component.show()
        self.table4.attach(self.component,3,4,2,3)
    
        list_product = open_db.get_product()
        self.product = gtk.combo_box_entry_new_text()
        self.product.set_tooltip_text("Enter the email id to whom the bug is assigned")
        for x in list_product:
          self.product.append_text(x)
        self.product.show()
        self.table4.attach(self.product,3,4,0,1)
        
        self.environment = self.builder.get_object("environment")
        self.description_new = self.builder.get_object("description_new")
        self.new_bug.show_all()
    
    def on_search_activate(self,widget,event = None):
        self.searchwin = self.builder.get_object("search_win")
        self.search_text = self.builder.get_object("searchtext")
        self.searchwin.show_all()
        
    def search_changed(self,widget,event = None):
        search_term = self.search.get_text()
        self.search_done(search_term)
        
    def search_done(self,text):
        list_entry = open_db.get_list('all')
        self.search_store = gtk.ListStore(str,str,str,str,str)       
        word = text
        for row in list_entry :
            if re.search(word,str(row)):
                self.search_store.append(row)
        self.bug_list_search = gtk.TreeView(self.search_store)
        self.cell_data = gtk.CellRendererText()
        i=0
        for title in self.list_tree :
            self.tvcolumn_search = gtk.TreeViewColumn(title)
            self.tvcolumn_search.pack_start(self.cell_data, True)
            self.tvcolumn_search.add_attribute(self.cell_data, 'text',i)
            self.bug_list_search.append_column(self.tvcolumn_search)
            i=i+1
        self.bug_list_search.set_headers_visible(True)
        self.bug_list_search.columns_autosize()
        gtk.Container.remove(self.scrolledwindow1,gtk.Bin.get_child(self.scrolledwindow1))
        self.scrolledwindow1.add_with_viewport(self.bug_list_search)
        self.selection_search = self.bug_list_search.get_selection()
        self.selection_search.connect('changed', self.list_select_changed)
        self.scrolledwindow1.show_all()
        
    def on_new_bug_btn_clicked(self,widget,data=None):
        self.new_bug_detail()
    
    def on_cancel_clicked(self,widget,data = None):
        self.new_bug.hide_all()
    
    def on_keyword_button_clicked(self,widget,event=None):
        print "Hi You are welcome"
        
    def list_select_changed(self,widget=None,event=None):
        self.list_pan.set_position(100)
        self.detail_pan.show()
        model, iter = self.selection_bug.get_selected()
        self.list_value = model.get_value(iter,0)
        #print self.list_value
        bug_found_detail = open_db.get_detail(self.list_value)
        
        self.bug_id_disp.set_text('#'+str(bug_found_detail[0]))
               
        detail = bug_found_detail[19]
        buff = self.comments.get_buffer()
        buff.set_text(detail)
        self.comments.set_buffer(buff)
        
        detail = bug_found_detail[18]
        buff = self.attachment.get_buffer()
        buff.set_text(detail)
        self.attachment.set_buffer(buff)
        
        detail = bug_found_detail[1]
        buff = self.description.get_buffer()
        buff.set_text(detail)
        self.description.set_buffer(buff)
        self.bug_description_disp.set_text(detail)
        
        self.assigned_to.set_text(bug_found_detail[3])
        self.creation_ts.set_text(bug_found_detail[4])
        self.delta_ts.set_text(bug_found_detail[5])
        self.bug_status.set_text(bug_found_detail[2])
        self.resolution.set_text(bug_found_detail[8])
        self.bug_file_loc.set_text(bug_found_detail[9])
        self.bug_severity.set_text(bug_found_detail[7])
        self.priority.set_text(bug_found_detail[6])
        self.target_milestone.set_text(bug_found_detail[16])
        self.reporter.set_text(bug_found_detail[10])
        self.rep_platform.set_text(bug_found_detail[14])
        self.op_sys.set_text(bug_found_detail[13])
        self.product.set_text(bug_found_detail[12])
        self.component.set_text(bug_found_detail[11])
        self.status_whiteboard.set_text(bug_found_detail[15])
        self.keywords.set_text(bug_found_detail[17])
        
    def tree_select_changed(self,widget=None,event=None):
        model, iter = self.selection.get_selected()
        self.tree_value = model.get_value(iter,0)
        #print self.tree_value
        self.newtab.set_text(self.tree_value)
        self.show_bugs(self.tree_value)
        win.window.show_all()
        self.detail_pan.hide()
        #list_entry = open_db.get_list(self.tree_value)
    
    def show_bugs(self,data):
        list_entry = open_db.get_list(data)
        self.list_store = gtk.ListStore(str,str,str,str,str)       
        for row in list_entry :
            self.list_store.append(row)
        self.bug_list_tree = gtk.TreeView(self.list_store)
        self.cell_data = gtk.CellRendererText()
        i=0
        for title in self.list_tree :
            self.tvcolumn_list = gtk.TreeViewColumn(title)
            self.tvcolumn_list.pack_start(self.cell_data, True)
            self.tvcolumn_list.add_attribute(self.cell_data, 'text',i)
            self.bug_list_tree.append_column(self.tvcolumn_list)
            i=i+1
        self.bug_list_tree.set_search_column(0)
        self.bug_list_tree.set_reorderable(True)
        self.bug_list_tree.set_headers_visible(True)
        self.bug_list_tree.columns_autosize()
        gtk.Container.remove(self.scrolledwindow1,gtk.Bin.get_child(self.scrolledwindow1))
        self.scrolledwindow1.add_with_viewport(self.bug_list_tree)
        self.selection_bug = self.bug_list_tree.get_selection()
        self.selection_bug.connect('changed', self.list_select_changed)
        
    
    def on_window_destroy(self, widget, data=None):
        gtk.main_quit()
       
    def on_error_clicked(self, widget, data=None):
        self.dialog.hide()
    
    def on_hide_detail_clicked(self,widget, data = None):
        self.detail_pan.hide()
    
    def on_messagedialog_destroy(self, widget, data=None):
        self.dialog.hide()
        
    def on_fillerror_clicked(self, widget, data=None):
        self.filldialog.hide()
        
    def on_filldialog_destroy(self, widget, data=None):
        self.filldialog.hide()
        
    def on_upload_clicked(self,widget,data = None):
        buff = self.environment.get_buffer()
        start = buff.get_iter_at_offset(0)
        end = buff.get_iter_at_offset(-1)
        self.environment_txt = buff.get_text(start, end)
        
        buff = self.description_new.get_buffer()
        start = buff.get_iter_at_offset(0)
        end = buff.get_iter_at_offset(-1)
        self.description_txt = buff.get_text(start, end)
        open_db.post(self.summary_txt, self.description_txt, '', self.assignee, '', self.keyword_txt)
    
    def on_save_draft_clicked(self,widget,data = None):
        open_db.save_bug(self.summary_txt, self.description_txt, '', self.assignee, '', self.keyword_txt)
    
    def on_attach_clicked(self,widget,data = None):
        dialog = gtk.FileChooserDialog("Open..",
                               None,
                               gtk.FILE_CHOOSER_ACTION_OPEN,
                               (gtk.STOCK_CANCEL, gtk.RESPONSE_CANCEL,
                                gtk.STOCK_OPEN, gtk.RESPONSE_OK))
        dialog.set_default_response(gtk.RESPONSE_OK)

        filter = gtk.FileFilter()
        filter.set_name("All files")
        filter.add_pattern("*")
        dialog.add_filter(filter)

        filter = gtk.FileFilter()
        filter.set_name("Images")
        filter.add_mime_type("image/png")
        filter.add_mime_type("image/jpeg")
        filter.add_mime_type("image/gif")
        filter.add_pattern("*.png")
        filter.add_pattern("*.jpg")
        filter.add_pattern("*.gif")
        filter.add_pattern("*.tif")
        filter.add_pattern("*.xpm")
        dialog.add_filter(filter)

        response = dialog.run()
        if response == gtk.RESPONSE_OK:
            self.attached_file = dialog.get_filename()
        elif response == gtk.RESPONSE_CANCEL:
            print 'Closed, no files selected'
        dialog.destroy()
    
    def on_adduser_clicked(self, widget, data=None):
        self.dialog.hide()
    
    def on_commentedit_clicked(self,widget,event = None):
        self.editdialog = self.builder.get_object("editdialog")
        self.editcmv = self.builder.get_object("textview2")
        self.editdialog.show_all()
        
    def login_clicked(self,widget,event=None):
        self.uname_text = self.uname.get_text()
        self.passwd = self.password.get_text()
        self.base = self.base_url.get_active_text()
        #self.topic = 'nautilus'#self.topics.get_text()
        if self.uname_text == '' or self.passwd == '' or self.base == '' :
            gtk.Dialog.run(self.filldialog)
            return
            
        try  :            
            logedin = open_db.login(self.uname_text,self.passwd,self.base)
            #print logedin
            logedin = True
            if logedin: 
                self.window0.hide()
                self.product_window.show_all()    
            else : 
                self.dialog.show()
                return
        except :
            self.dialog.show()
            return
    def load_window_hide(self,widget,event = None):
        open_db.loadwindow.hide()
        self.window.show_all()
            
        
    def finish_clicked(self,widget,event = None):
        open_db.put_value(self.uname_text,self.passwd,self.base,self.topic)
        self.product_window.hide()
        lock = thread.allocate_lock()
        open_db.bug_got = 0
        open_db.total_bug = 32149
        """
        open_db.loadwin()
        product = open_db.account_check()[3]
        list_t =  product.split('_')[1:]
        print list_t
        thread.start_new_thread(open_db.get_all_the_bugs,(list_t,lock))
            
        """
        try:
            open_db.loadwin()
            product = open_db.account_check()[3]
            list_t =  product.split("_")[1:]
            #print list_t
            
            thread.start_new_thread(open_db.get_all_the_bugs,(list_t,lock))
            #self.window.show_all()
        except:
            open_db.loadwindow.hide()
            self.window.show_all()
            #open_db.get_all_the_bugs('nautilus')
        
        
        """
        open_db.bug_got = 0;
        open_db.total_bug = 32149;
        open_db.loadwin(float(0.0))
        
        thread.start_new_thread(open_db.get_all_the_bugs,(self.topic,lock))
        open_db.loadwindow.hide()
        #open_db.get_all_the_bugs(self.topic)
        self.window.show_all()

        try  :
            logedin = open_db.login(uname_text,passwd,base)
            print logedin
            logedin = True
            if logedin: 
                try:
                    self.window0.hide()
                    open_db.put_value(uname_text,passwd,base,self.topic)
                    open_db.loadwin(float(0.0))
                    thread.start_new_thread(open_db.get_all_the_bugs,(self.topic,))

                    open_db.loadwindow.hide()
                    self.window.show_all()
                except:
                    self.window0.hide()
                    open_db.put_value(uname_text,passwd,base,self.topic)
                    self.window.show_all()
                    #open_db.get_all_the_bugs('nautilus')
            else : 
                self.dialog.show()
        except :
            self.dialog.show()
        """
        
        
        
#////////////////////////////////////////////////help and about///////////////
    def on_help_activate(self,widget,data=None):
        import webbrowser
        webbrowser.open_new_tab("http://bamachrn.fedorapeople.org/openzilla/openzilla_help.html")
    #//help_page = 

    def on_about_clicked(self, widget, data=None):
        dialog = gtk.AboutDialog()
        dialog.set_name('openZilla')
        dialog.set_copyright('(c) 2010-11 Bamacharan Kundu')
        dialog.set_website('http://gitorious.org/openzilla/openzilla')
        dialog.set_authors(['Bamacharan Kundu <bamachrn@gmail.com>'])
        dialog.set_program_name('openzilla')
        dialog.run()
        dialog.destroy()
        
#################//////////////////////////////modify//////////////////
    def on_searchcancel_clicked(self,widget,data = None):
        self.searchwin.hide()

    def on_searchok_clicked(self,widget,event = None):
        conts = self.search_text.get_buffer()
        start = conts.get_iter_at_offset(0)
        end = conts.get_iter_at_offset(-1)
        searchitem = conts.get_text(start, end)
        self.search_done(searchitem)
        self.searchwin.hide()
    
    def on_descedit_clicked(self,widget,data = None):
        self.description.set_editable(True)
        
    def on_commencancel_clicked(self,widget,data = None):
        self.editdialog.hide()
    
    def on_commenedit_clicked(self,widget,event = None):
              
        conts = self.editcmv.get_buffer()
        start = conts.get_iter_at_offset(0)
        end = conts.get_iter_at_offset(-1)
        editcomment = conts.get_text(start, end)
        bugid = self.bug_id_disp.get_text()[1:]
        open_db.save_comment(bugid,editcomment)
        self.editdialog.hide()
    def on_editbug_clicked(self,widget,event =None):
        self.assigned_to.set_editable(True)
        self.bug_status.set_editable(True)
        self.resolution.set_editable(True)
        self.bug_file_loc.set_editable(True)
        self.bug_severity.set_editable(True)
        self.priority.set_editable(True)
        self.target_milestone.set_editable(True)
        self.rep_platform.set_editable(True)
        self.op_sys.set_editable(True)
        self.product.set_editable(True)
        self.component.set_editable(True)
        self.status_whiteboard.set_editable(True)
        self.keywords.set_editable(True)

    def on_saveedit_clicked(self,widget,event = None):
        data = {}
        self.inactive_edit()
        self.bugid = self.bug_id_disp.get_text()[1:]
        data['bugid']=self.bugid
        self.mod_assigned_to = self.assigned_to.get_text()
        data['assigned_to'] = self.mod_assigned_to
        self.mod_bug_status = self.bug_status.get_text()
        data['bug_status'] = self.mod_bug_status
        self.mod_resolution = self.resolution.get_text()
        data['resolution']=self.mod_resolution
        self.mod_bug_file_loc = self.bug_file_loc.get_text()
        data['bug_file_loc']=self.mod_bug_file_loc
        self.mod_bug_severity = self.bug_severity.get_text()
        data['bug_severity'] = self.mod_bug_severity
        self.mod_priority = self.priority.get_text()
        data['priority'] = self.mod_priority
        self.mod_target_milestone = self.target_milestone.get_text()
        data['target_milestone'] = self.mod_target_milestone
        self.mod_rep_platform = self.rep_platform.get_text()
        data['rep_platform'] = self.mod_rep_platform
        self.mod_op_sys = self.op_sys.get_text()
        data['op_sys'] = self.mod_op_sys
        self.mod_product = self.product.get_text()
        data['product'] = self.mod_product
        self.mod_component = self.component.get_text()
        data['component'] = self.mod_component
        self.mod_status_whiteboard = self.status_whiteboard.get_text()
        data['status_whiteboard'] = self.mod_status_whiteboard
        self.mod_keywords = self.keywords.get_text()
        data['keywords'] = self.mod_keywords
        
        conts = self.description.get_buffer()
        start = conts.get_iter_at_offset(0)
        end = conts.get_iter_at_offset(-1)
        editdescription = conts.get_text(start, end)
        data['short_desc'] = editdescription
        
        
        open_db.modify_bug(data)
        
    def inactive_edit(self):
        self.assigned_to.set_editable(False)
        self.bug_status.set_editable(False)
        self.resolution.set_editable(False)
        self.bug_file_loc.set_editable(False)
        self.bug_severity.set_editable(False)
        self.priority.set_editable(False)
        self.target_milestone.set_editable(False)
        self.rep_platform.set_editable(False)
        self.op_sys.set_editable(False)
        self.product.set_editable(False)
        self.component.set_editable(False)
        self.status_whiteboard.set_editable(False)
        self.keywords.set_editable(False)
        self.attachment.set_editable(False)
        self.description.set_editable(False)
        
    
    def on_undoedit_clicked(self,widget,envent = None):
        
        self.unedassig = self.assigned_to.get_text()
        self.unedcreat = self.creation_ts.get_text()
        self.uneddelta = self.delta_ts.get_text()
        self.unedstata = self.bug_status.get_text()
        self.unedresol = self.resolution.get_text()
        self.unedfillo = self.bug_file_loc.get_text()
        self.unedsever = self.bug_severity.get_text()
        self.unedprior = self.priority.get_text()
        self.unedmiles = self.target_milestone.get_text()
        self.unedrepor = self.reporter.get_text()
        self.unedplatf = self.rep_platform.get_text()
        self.unedopsys = self.op_sys.get_text()
        self.unedprodu = self.product.get_text()
        self.unedcompo = self.component.get_text()
        self.unedwhite = self.status_whiteboard.get_text()
        self.uneddescr = self.description.get_text()
        self.unedkeywo = self.keywords.get_text()
        
        self.get_data()
        
    def get_data(self):
        bug_found_detail = open_db.get_detail(self.bug_id_disp.get_text()[1:])
        
        self.assigned_to.set_text(bug_found_detail[3])
        self.creation_ts.set_text(bug_found_detail[4])
        self.delta_ts.set_text(bug_found_detail[5])
        self.bug_status.set_text(bug_found_detail[2])
        self.resolution.set_text(bug_found_detail[8])
        self.bug_file_loc.set_text(bug_found_detail[9])
        self.bug_severity.set_text(bug_found_detail[7])
        self.priority.set_text(bug_found_detail[6])
        self.target_milestone.set_text(bug_found_detail[16])
        self.reporter.set_text(bug_found_detail[10])
        self.rep_platform.set_text(bug_found_detail[14])
        self.op_sys.set_text(bug_found_detail[13])
        self.product.set_text(bug_found_detail[12])
        self.component.set_text(bug_found_detail[11])
        self.status_whiteboard.set_text(bug_found_detail[15])
        self.description.set_text(bug_found_detail[2])
        self.keywords.set_text(bug_found_detail[17])
        
    def on_redoedit_clicked(self,widget,envent = None):
        self.assigned_to.set_text(self.unedassig)
        self.creation_ts.set_text(self.unedcreat)
        self.delta_ts.set_text(self.uneddelta)
        self.bug_status.set_text(self.unedstata)
        self.resolution.set_text(self.unedresol)
        self.bug_file_loc.set_text(self.unedfillo)
        self.bug_severity.set_text(self.unedsever)
        self.priority.set_text(self.unedprior)
        self.target_milestone.set_text(self.unedmiles)
        self.reporter.set_text(self.unedrepor)
        self.rep_platform.set_text(self.unedplatf)
        self.op_sys.set_text(self.unedopsys)
        self.product.set_text(self.unedprodu)
        self.component.set_text(self.unedcompo)
        self.status_whiteboard.set_text(self.unedwhite)
        self.description.set_text(self.uneddescr)
        self.keywords.set_text(self.unedkeywo)
        
    def on_canceledit_clicked(self,widget,envent = None):
        self.get_data()
        self.inactive_edit()
        
    def on_addcc_clicked(self,widget,envent = None):
        print "redo done"
        
    def on_removecc_clicked(self,widget,envent = None):
        print "redo done"
        

if __name__ == "__main__":
    open_db = openzilla_db.openzillaSql()
    win = openzillaGUI()
    acc_test = open_db.account_check()
    #print acc_test
    
    #win.new_bug.show_all()
    #print acc_test
    #win.product_window.show_all()
    #win.editdialog.show_all()
    #win.window0.show_all()
    #win.window.show_all()
    #win.searchwin.show_all()
    #open_db.loadwin(float(20.0))
    if not acc_test:
        win.window0.show_all()
    else :
        
        win.window.show_all()
        win.detail_pan.hide()
        def second_thread(topic):
            for step in range(99999):
                try :
                    print "Entered"
                    authentic = open_db.login(acc_test[0],acc_test[1],acc_test[2])
                    lock = thread.allocate_lock()
                    open_db.get_all_the_bugs(topic,lock)
            
                except : 
                    print "error in getting bugs"
                    time.sleep(120)
        product = open_db.account_check()[3]
        list_t =  product.split("_")[1:]
        #print list_t
            
        thread.start_new_thread(second_thread,(list_t,))
    
    """
    def second_thread(topic):
        print 'entered'
        print acc_test[0],acc_test[1],acc_test[2]
        open_db.login(acc_test[1],acc_test[2],acc_test[0])
        open_db.get_all_the_bugs(topic)"""
        
        
    #thread.start_new_thread(second_thread,('nautilus',))
    gtk.main()
    
